#include "stm32f10x.h"
#include "stdio.h"
#include "string.h"
#include "stm32f10x_it.h"
#include "radio/sx127x_driver.h"
#include "example/example_TX.h"
#include "example/example_RX.h"
#include "example/example_CAD.h"

/*
 * Copyright (c) 2019-2020 AIThinker.yangbin All rights reserved.
 *
 * ֻSX127Xdemoο֤ȶԡ
 *
 * author     Specter
 */
#define TEST_MOD	1	//ģʽ 1ʾʽģʽ0ʾʽģʽ(ĬΪģʽ)
#if !TEST_MOD
	#define IS_TX_MOD 0	//1ʾģʽ0ʾģʽ(ģʽЧ)
#endif

#pragma import(__use_no_semihosting)             
//׼Ҫֵ֧ĺ
struct __FILE 
{
	int handle;
};

FILE __stdout;       
//_sys_exit()Ա⹤ڰ״̬
void _sys_exit(int x) 
{ 
	x = x; 
} 
//ضfputc
//ҪMCUϣprintfĸȷ __WAIT_TODO__
int fputc(int ch, FILE *f)
{
	//ע⣺USART_FLAG_TXEǼ鷢ͻǷΪգҪڷǰ飬߷Чʣߵʱܵһַʧ
	//USART_FLAG_TCǼ鷢ɱ־ڷͺ飬˯߶ʧַ⣬Чʵͣ͹зͻѾΪˣԽһˣΪҪȴɣЧʵͣ
	//ҪһãһЧ
	
	//ѭȴֱͻΪ(TX Empty)ʱԷݵ
  while (USART_GetFlagStatus(USART2, USART_FLAG_TXE) == RESET)
  {}
	USART_SendData(USART2, (uint8_t) ch);

  /* ѭȴֱͽ*/
  //while (USART_GetFlagStatus(USART2, USART_FLAG_TC) == RESET)
  //{}

	return ch;
}

void uartInit(){
	USART_InitTypeDef USART_InitStructure;
	GPIO_InitTypeDef  GPIO_InitStructure;

	USART_DeInit(USART2);  //λ
	
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);//עAPB1APB2ʱʹܺһ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);	    //ʹָ˿ʱ
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;	 //IOٶΪ50MHzﲻôΣֱдٶ50MHZ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_AF_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);	//ʼGPIO
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOA, &GPIO_InitStructure);	//ʼGPIO
	
	//USART
	USART_InitStructure.USART_BaudRate = 115200;	//ôڲ
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;	//ֳΪ8
	USART_InitStructure.USART_StopBits = USART_StopBits_1;	//1ֹͣλ
	USART_InitStructure.USART_Parity = USART_Parity_No;	//żУ
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;	//
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;	//շģʽ
	USART_Init(USART2, &USART_InitStructure); //USART
	USART_Cmd(USART2, ENABLE);                    //ʹUSART
}

void delayMsBySystick(uint32_t timeoutMs){
	uint32_t systickBak,currTick;
	systickBak=GetTick();
	while(1){
		currTick=GetTick();
		if(currTick>=systickBak){
			if(currTick-systickBak>timeoutMs){
				return;
			}
		}else{
			//currTick
			if(currTick+(~systickBak)>timeoutMs){
				return;
			}
		}
	}
}
int main(void){
	tLoRaSettings stting={435000000,20,7,12,1,0x0005};	//Ƶ435M20dbm125kHzSF=124/5,ǰ볤0x0005
	SysTick_Config(SystemCoreClock/1000);
	uartInit();
	printf("version:%s\r\n",VERSION);
	
	g_Radio.Init(&stting);	//ʼ
	printf("init OK\r\n");
	while(1){
		#if TEST_MOD
			//
			exampleTx();	//Ͳԣɵȴ1sٴη
			//exampleRx();	//ѭ
			//exampleCAD();	//CADѭ
		#else	//else of #if IS_TX_MOD
			//շ
			#if IS_TX_MOD
				if(0==sx127xSend((uint8_t *)"aithinker",strlen("aithinker"),1000)){	//ݣʱʱ1000Ms
					printf("send ok\r\n");
				}else{
					printf("send timeout\r\n");
				}
				delayMsBySystick(1000);
			#else	
		    uint8_t u8_ret,rxBuf[128]={0},rxCount=128;
				rxCount=255;
				memset(rxBuf,0,255);
				printf("start rx\r\n");
				u8_ret=sx127xRx(rxBuf,&rxCount,2000);	//ݣrxBuf洢ݣrxCount洢յݳȣʱ1000Ms
				switch(u8_ret){
					case 0:
						printf("rx done\r\n  len:%d\r\n  playload:%s\r\n",rxCount,rxBuf);
						break;
					case 1:
					case 2:
						printf("rx timeout ret:%d\r\n",u8_ret);
						break;
					default:
						printf("unknow ret:%d\r\n",u8_ret);
						break;
				}
			#endif	//end of #if IS_TX_MOD
		#endif	//end of #if IS_TX_MOD
	}
}
